Structure t_MMC
PageCode .b ; Page Code 1
PageLen.b ; Page len1
rsvd2.b[8] ; reserved8
ReadSupported.b ; readable formats1
WriteSupported.b ; writable formats1
misc.b[4] ; misc. 4
MaxReadCDSpeed.b[2] ; max. read speed 2 0-17
NumVolLevels.b[2] ; num. volume levels2 18-19
BufferSize.b[2] ; buffer size 2
CurrReadCDSpeed.b[2] ; curr. read speed2
rsvd.b ; reserved1
misc2.b ; misc. 1
MaxWriteCDRSpeed.b[2] ; max. write speed
CurrWriteSpeed.b[2] ; curr write speed
rsvd3.b[20] ; other
Rest.b[32]
EndStructure

Structure t_SCSI_ADDRESS
    Length.l     ; data len
    PortNumber.b     ; Host Adapter
    PathId.b     ; ?
    TargetId.b     ; Target
    Lun.b     ; Logical Unit Number
EndStructure

Structure t_OVERLAPPED
    Internal.l     ;
    InternalHigh.l     ;
    offset.l     ;
    OffsetHigh.l     ;
    hEvent.l     ;
EndStructure

Structure t_HAID
    HA.b     ; Host Adapter
    ID.b     ; Target
    DEV_Lun.b      ; Target Logical Unit Number
    DEV_DeviceType.b      ; Devicetype
EndStructure

Structure t_InqDat
    PDT.b     ; drive type
    PDQ.b     ; removable drive
    ver.b     ; MMC Version (zero for ATAPI)
    RDF.b     ; interface depending field
    DLEN.b     ; additional len
    rsv1.b[2]     ; reserved
    Feat.b     ; ?
    VID.b[8]     ; vendor
    PID.b[16]     ; Product
    PVER.b[4]     ; revision (= Firmware Version)
    FWVER.b[21]     ; extra data
EndStructure

Structure t_SPTD
    Length.w ; data len
    ScsiStatus.b    ; SCSI Status
    PathId.b    ; Bus Number
    TargetId.b    ; Target
    Lun.b    ; Logical Unit Number
    CdbLength.b    ; CDB (Command Descriptor Block)
    SenseInfoLength.b    ; Sense Info len
    DataIn.b    ; data direction
    padding0.b[3]
    DataTransferLength.l    ; data transfer length
    TimeOutValue.l    ; command timeout
    DataBuffer.l    ; Pointer to the data buffer
    SenseInfoOffset.l    ; Sense Info Offset
    Cdb.b[16]    ; Command Descriptor Block
    Fill.b[3]    ;
EndStructure

Structure t_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER
    spt.t_SPTD     ; SPTD structure
    Fill.l       ;
    SenseBuffer.b[32]       ; Debugging-Info from the drive
EndStructure

Structure t_ReadFeatures
CDR.b		;CD-R
CDRW.b  ;CD-RW
DVDROM.b  ;DVD-ROM
DVDR.b  ;DVD-R
DVDRW.b  ;DVD-RW
DVD_R_DL.b  ;DVD-R DL
DVD_RW_DL.b  ;DVD-RW DL
DVD_P_R.b  ;DVD+R
DVD_P_RW.b  ;DVD+RW
DVD_P_R_DL.b  ;DVD+R DL
DVD_P_RW_DL.b  ;DVD+RW DL
DVDRAM.b  ;DVD-RAM
BD_ROM.b  ;Blue_ray_Disk-ROM
BD_R.b  ;Blue_ray_Disk-R
BD_RW.b  ;Blue_ray_Disk-RW
HD_DVD_ROM.b  ;HD DVD-ROM
HD_DVD_R.b  ;HD DVD-R
HD_DVD_RAM.b  ;HD DVD-RAM
SubChannels.b  ;Sub-Channels
SubChannelsCorrected.b  ;Sub-Channels corrected
SubChannelsFromLeadIn.b  ;Sub-Channels from Lead-In
C2ErrorPointers.b  ;C2 Error Pointers
ISRC.b  ;International Standard Recording Code
UPC.b  ;Universal Product Code
BC.b  ;Bar Code
Mode2Form1.b  ;Mode 2 Form 1 sectors
Mode2Form2.b  ;Mode 2 Form 2
MultiSession.b  ;Multi-Session CDs
CDDARawRead.b  ;Audio sectors
MultiRead.b
DDCD_Read.b
EndStructure

Structure t_WriteModes
Raw16.b  ; Raw + 16
Raw16Test.b  ; Raw + 16 + Test-Mode
Raw96P.b  ; Raw + 96 with packed R-W subchannels
Raw96R.b  ; Raw + 96 with raw R-W subchannels
Raw96PTest.b  ; Raw + 96 with packed R-W subchannels + Test-Mode
Raw96RTest.b  ; Raw + 96 with raw R-W subchannels + Test-Mode
SAO.b  ; Session At Once
SAOR96P.b  ; SAO with packed R-W subchannels
SAOR96R.b  ; SAO with raw R-W subchannels
SAOTest.b  ; Session At Once + Test-Mode
SAOR96PTest.b  ; SAO with packed R-W subchannels + Test-Mode
SAOR96RTest.b  ; SAO with raw R-W subchannels + Test-Mode
TAO.b  ; Track At Once
TAOTest.b  ; Track At Once + Test-Mode
EndStructure

Structure t_WriteFeatures
CDR.b  ;CD-R
CDRW.b  ;CD-RW
DVDR.b  ;DVD-R
DVD_R_DL.b  ;DVD-R DL
DVDRW.b  ;DVD-RW
DVD_RW_DL.b  ;DVD-RW DL
DVD_P_R.b  ;DVD+R
DVD_P_R_DL.b  ;DVD+R DL
DVD_P_RW.b  ;DVD+RW
DVD_P_RW_DL.b  ;DVD+RW DL
DVDRAM.b  ;DVD-RAM
BD_R.b  ;Blue_ray_Disk-R
BD_RW.b  ;Blue_ray_Disk-RW
HD_DVD_R.b  ;HD DVD-R
HD_DVD_RAM.b  ;HD DVD-RAM
TestMode.b  ;Test-Mode
BURNProof.b  ;BURN-Proof
LAYER_JUMP.b  ;Layer Jump Recording
CD_TAO.b
Def_Management.b
CDRWCAV_Write.b
MRW.b
DDCDR_Write.b
DDCDRW_Write.b
WriteModes.t_WriteModes   ; supported write modes
EndStructure

Structure t_OtherFeats
PowerManagement.b
EmbeddedChanger.b
CDAudioAnalogPlay.b
MicrocodeUpgrade.b
TimeOut.b
RealTimeStreaming.b
LogicalUnitSerialNumber.b
DiscControlBlocks.b
DVD_CSS.b
DVD_CPRM.b
FirmwareDate.b
AnalogAudio.b  ; analog audio playback?
JitterCorrection.b  ; jitter effect correction?
LockMedia.b  ; can lock media?
MRW.b ;Mount Rainier Write
VolumeLevels.l
BufferSize.l
LoadingMechanism.s  
DriveInterface.s
EndStructure

Structure t_Speed
MaxRSpeed.l  ;max CD read speed
MaxWCDRSpeed.l  ;max CDR write speed
CurrRSpeed.l  ;current CD read speed
CurrWSpeed.l  ;current CDR write speed
MaxWCDRWSpeed.l ;max CDRW write speed
EndStructure

Structure OpticalDriveInfo
VendorID.s; return vendor
ProductID.s ; return product id
Firmware.s; return firmware version
ExData.s ; extra data
BufferSize.l   ; buffer size
BusNo.b
TargetNo.b
LunNo.b
ReadFeatures.t_ReadFeatures
WriteFeatures.t_WriteFeatures  ; write features
OtherFeatures.t_OtherFeats   ; other features
Speeds.t_Speed  ; speeds
EndStructure
;/////////////////////////////////////\
;/////////////////////// enumerations //=>>>
;//////////////////////////////////////

Enumeration
#SCSI_IOCTL_DATA_OUT           ; send data to the drive
#SCSI_IOCTL_DATA_IN            ; retrieve data from the drive
#SCSI_IOCTL_DATA_UNSPECIFIED   ; no transfer
EndEnumeration

Enumeration
#SRB_DIR_READ = 1
#SRB_DIR_IN = $8              ; retrieve data from the drive
#SRB_DIR_OUT = $10            ; send data to the drive
EndEnumeration

;/////////////////////////////////////\
;/////////////////////// constants    //=>>>
;//////////////////////////////////////
Global IOCTL_SCSI_PASS_THROUGH_DIRECT.l = 315412
Global IOCTL_SCSI_GET_ADDRESS.l = 266264

Global Dim Language.s(1); For the feature bit values
Language(0)="NO"
Language(1)="YES"

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 35
; FirstLine = 35
; EnableXP